<?php
/**
 * @file
 * Contains Login Settings for miniOrange OAuth Login Module.
 */

/**
 * Showing Settings form.
 */
function miniorange_oauth_login_options($form, &$form_state) {
  global $base_url;
  drupal_add_css( drupal_get_path('module', 'miniorange_oauth_client'). '/css/bootstrap.min.css' , array('group' => CSS_DEFAULT, 'every_page' => FALSE));
  drupal_add_css( drupal_get_path('module', 'miniorange_oauth_client'). '/css/style_settings.css' , array('group' => CSS_DEFAULT, 'every_page' => FALSE));
  drupal_add_js(drupal_get_path('module', 'miniorange_oauth_client') . '/js/slide_support_button.js');

  $enforce_https_checkbox = variable_get('miniorange_oauth_client_enforce_https_checkbox');

  $form['header_top_style_1'] = array('#markup' => '<div class="mo_oauth_table_layout_1">');

  $form['markup_top'] = array(
    '#markup' => '<div class="mo_oauth_table_layout mo_oauth_container">',
  );

  $form['markup_top_vt_start'] = array(
    '#markup' => '<b><span style="font-size: 17px;">Sign in Settings</span></b><br><br><hr><br>',
  );

  $prefixname = '<div class="mo_oauth_row"><div class="mo_oauth_name">';
  $suffixname = '</div>';

  $prefixvalue = '<div class="mo_oauth_value">';
  $suffixvalue = '</div></div>';
  $module_path = drupal_get_path('module', 'miniorange_oauth_client');

  $form['miniorange_oauth_client_base_url_title'] = array(
    '#prefix' => $prefixname,
    '#suffix' => $suffixname,
  );
  $form['miniorange_oauth_client_base_url_trying'] = array(
    '#type' => 'checkbox',
    '#title' => t('Enforce HTTPS Callback URL'),
    '#default_value' => $enforce_https_checkbox,
    '#description' => t('<b>Note:</b>Check this option if the OAuth Provider only support HTTPS Callback URL and you have an HTTP site.'),
    '#attributes' => array('id'=>'mo_oauth_vt_baseurl'),
  );

  $form['miniorange_oauth_client_base_url'] = array(
    '#prefix' => $prefixvalue,
    '#suffix' => $suffixvalue,
  );




  $form['miniorange_oauth_client_siginin'] = array(
    '#type' => 'submit',
    '#value' => t('Update'),
    '#submit' => array('miniorange_oauth_save_signin_settings'),
    '#suffix' => '<br>',
  );

  $form['markup_bottom_vt_start4'] = array(
    '#markup' => '<br><br><b><span style="font-size: 17px;">Advanced Sign in Settings<a href="' . $base_url . '/admin/config/people/miniorange_oauth_client/licensing"> [Premium, Enterprise]</a></span></b><br><hr><br/>'
  );

  $form['miniorange_oauth_force_auth'] = array(
    '#type' => 'checkbox',
    '#title' => t('Protect website against anonymous access'),
    '#disabled' => TRUE,
    '#description' => t('<b>Note: </b>Users will be redirected to your OAuth Server for login in case user is not logged in and tries to access website.<br><br><br>'),
  );
  $form['miniorange_oauth_auto_redirect'] = array(
    '#type' => 'checkbox',
    '#title' => t('Check this option if you want to <b>replace Drupal login form with IDP/OAuth Provider login from</b>'),
    '#disabled' => TRUE,
    '#description' => t('<b>Note: </b>Users will be redirected to your OAuth Server for login when the login page is accessed.<br><br><br>'),
  );
  $form['miniorange_oauth_enable_backdoor'] = array(
    '#type' => 'checkbox',
    '#title' => t('Check this option if you want to enable <b>backdoor login </b>'),
    '#disabled' => TRUE,
    '#description' => t('<b>Note</b>: Checking this option creates a backdoor to login to your Website using Drupal credentials incase you get locked out of your OAuth Server.
                <br><br><br><br>'),
  );

  $form['markup_auto-create_users_vt_start'] = array(
    '#markup' => '<b><span style="font-size: 17px;">Auto Create Users<a href="' . $base_url . '/admin/config/people/miniorange_oauth_client/licensing"><b> [Standard, Premium, Enterprise]</b></a></span></b><br><hr><br>'
  );
  $form['miniorange_oauth_disable_autocreate_users'] = array(
    '#type' => 'checkbox',
    '#title' => t('Check this option if you want to enable <b>auto creation</b> of users if user does not exist.'),
    '#disabled' => TRUE,
  );

  $form['markup_bottom_vt_start'] = array(
    '#markup' => '<br><br><br><b><span style="font-size: 17px;">Domain & Page Restriction <a href="' . $base_url . '/admin/config/people/miniorange_oauth_client/licensing"><b>[Enterprise]</b></a></span></b><br><hr><br/>'
  );

  $form['miniorange_oauth_client_allowed_domains'] = array(
    '#markup' => '<b>Allowed Domains  </b><div class="mo_oauth_tooltip"><img src="'.$base_url.'/'. $module_path . '/includes/images/info.png" alt="info icon" height="15px" width="15px"></div><div class="mo_oauth_tooltiptext"><b>Note: </b> Enter <b>semicolon(;) separated</b> domains. Other than these domains will not be allowed to do SSO</div>',
    '#prefix' => $prefixname,
    '#suffix' => $suffixname,
  );

  $form['miniorange_oauth_client_allowed_domains_field'] = array(
    '#type' => 'textfield',
    '#attributes' => array('style' => 'width:73%','placeholder' => 'Enter semicolon(;) separated domains (Eg. xxxx.com; xxxx.com)'),
    '#disabled' => TRUE,
    '#prefix' => $prefixvalue,
    '#suffix' => $suffixvalue,
  );

  $form['miniorange_oauth_client_restricted_domains_title'] = array(
    '#markup' => '<b>Restricted Domains  </b><div class="mo_oauth_tooltip"><img src="'.$base_url.'/'. $module_path . '/includes/images/info.png" alt="info icon" height="15px" width="15px"></div><div class="mo_oauth_tooltiptext"><b>Note: </b> Enter <b>semicolon(;) separated</b> domains. These domains will not be allowed to do SSO</div>',
    '#prefix' => $prefixname,
    '#suffix' => $suffixname,
  );

  $form['miniorange_oauth_client_restricted_domains_field'] = array(
    '#type' => 'textfield',
    '#attributes' => array('style' => 'width:73%','placeholder' => 'Enter semicolon(;) separated domains (Eg. xxxx.com; xxxx.com)'),
    '#disabled' => TRUE,
    '#prefix' => $prefixvalue,
    '#suffix' => $suffixvalue,
  );

  $form['miniorange_oauth_client_page_restriction_title'] = array(
    '#markup' => '<b>Page Restriction</b>  <div class="mo_oauth_tooltip"><img src="'.$base_url.'/'. $module_path . '/includes/images/info.png" alt="info icon" height="15px" width="15px"></div><div class="mo_oauth_tooltiptext"><b>Note: </b> Enter <b>semicolon(;) separated</b> URLs to restrict anonymous access</div>',
    '#prefix' => $prefixname,
    '#suffix' => $suffixname,
  );

  $form['miniorange_oauth_client_page_restriction_field'] = array(
    '#type' => 'textfield',
    '#attributes' => array('style' => 'width:73%','placeholder' => 'Enter semicolon(;) separated page URLs (Eg. xxxx.com/yyy; xxxx.com/yyy)'),
    '#disabled' => TRUE,
    '#prefix' => $prefixvalue,
    '#suffix' => $suffixvalue,
  );


  $form['markup_role_signin'] = array(
    '#markup' => '<br><h3>Customize Redirection after SSO login and logout <a href="' . $base_url . '/admin/config/people/miniorange_oauth_client/licensing"><b>[Premium, Enterprise]</b></a></h3><hr><br>'
  );

  $form['miniorange_oauth_client_login_url'] = array(
    '#type' => 'textfield',
    '#title'=> t('Redirect URL after login'),
    '#id' => 'text_field',
    '#required' => FALSE,
    '#disabled' => TRUE,
    '#attributes' => array('style' => 'width:73%;','placeholder' => 'Enter Login URL'),
  );
  $form['miniorange_oauth_client_logout_url'] = array(
    '#type' => 'textfield',
    '#title'=> t('Redirect URL after logout'),
    '#id' => 'text_field',
    '#required' => FALSE,
    '#disabled' => TRUE,
    '#attributes' => array('style' => 'width:73%;','placeholder' => 'Enter Logout URL'),
  );

  $form['miniorange_oauth_client_siginin1'] = array(
    '#type' => 'button',
    '#disabled' => TRUE,
    '#value' => t('Save Configuration'),
  );
  $form['mo_header_style_end'] = array('#markup' => '</div>');
  Utilities::nofeaturelisted($form, $form_state);
  $form['mo_markup_div_imp']=array('#markup'=>'</div>');
  Utilities::AddSupportButton($form, $form_state);
  return $form;
}
/**
 * Send support query.
 */
function send_support_query(&$form, $form_state)
{
  $email = trim($form['miniorange_oauth_email_address_support']['#value']);
  $phone = $form['miniorange_oauth_phone_number_support']['#value'];
  $query = trim($form['miniorange_oauth_support_query_support']['#value']);
  Utilities::send_query($email, $phone, $query);
}
function rfd(&$form, $form_state) {

  global $base_url;
  drupal_goto($base_url.'/admin/config/people/miniorange_oauth_client/request_for_demo');
}
/**
 * This function saves the values in the Sign in Settings tab.
 */
function miniorange_oauth_save_signin_settings($form, &$form_state) {
  $enforce_https = trim($form['miniorange_oauth_client_base_url_trying']['#value']);
  global $base_url;

  if($enforce_https){
    $baseUrlValue = preg_replace('/http:\/\//', 'https://', $base_url);
    variable_set('miniorange_oauth_client_base_url', $baseUrlValue);
    $miniorange_auth_client_callback_uri = $baseUrlValue."/?q=mo_login";
  }else{
    variable_set('miniorange_oauth_client_base_url', '');
    $miniorange_auth_client_callback_uri = $base_url."/?q=mo_login";
  }

  variable_set('miniorange_oauth_client_enforce_https_checkbox', $enforce_https);
  $appValue = variable_get('miniorange_oauth_client_appval');
  $appValue['callback_uri'] = $miniorange_auth_client_callback_uri;
  variable_set('miniorange_oauth_client_appval',$appValue);
  variable_set('miniorange_auth_client_callback_uri',$miniorange_auth_client_callback_uri);
  drupal_set_message(t('Signin Settings successfully saved'));
}
